SystemOrganization addCategory: #'GT-Playground'!

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:56'!
acceptAction: anAction 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptAction: anAction].! !

!GLMSystemWindow methodsFor: '*GT-Playground' stamp: 'AndreiChis 9/8/2014 22:55'!
acceptContents: aString 
	"Be compatible with edit:label:accept:.
	Not the best place for this method.
	Interim situation to move things forward..."
	self flag: #TODO.
	self model ifNotNil: [:aModel | aModel acceptContents: aString].

	! !

Object subclass: #GTPlayBook
	instanceVariableNames: 'pages'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayBook class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/19/2014 21:34'!
cacheDirectory
	^ 'play-cache/' asFileReference ensureCreateDirectory! !

!GTPlayBook class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/18/2014 21:48'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTPlayBook class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 10/19/2014 21:34'!
reset
	
	instance := nil! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 22:13'!
addPage: aPage
	self pages addFirst: aPage! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/20/2014 07:11'!
addPageIfInteresting: aPage
	aPage content asString trimBoth isEmpty
		ifFalse: [ self pages addFirst: aPage ]! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:35'!
initialize
	pages := (self class cacheDirectory files 
		select: [ :each | each extension = 'ph' ] 
		thenCollect: [ :each | GTPlayPage new content: (each readStreamDo: #contents) ]) asOrderedCollection ! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages
	^ pages! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:49'!
pages: anObject
	pages := anObject! !

!GTPlayBook methodsFor: 'accessing' stamp: 'TudorGirba 10/18/2014 21:51'!
removePage: aPage
	self pages remove: aPage! !

Object subclass: #GTPlayPage
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayPage commentStamp: 'TudorGirba 2/8/2014 22:59' prior: 0!
GTPlayground open!

!GTPlayPage methodsFor: 'compatibility-tools' stamp: 'AndreiChis 9/30/2014 20:44'!
acceptContents: aString

	self flag: #TODO. "Need support for what lies in the comment down here"
	"self fileName ifNotNil: [ self saveString: aString toFile: self fileName ].

	acceptAction ifNotNil:[acceptAction value: aString]."
	self content: aString.
	^ true! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:34'!
cacheDirectory
	^ GTPlayBook cacheDirectory! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content
	^ content! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:21'!
content: aString
	content := aString.
	aString isEmpty 
		ifTrue: [ self fileReference ensureDelete ]
		ifFalse: [ self fileReference writeStreamDo: [ :s | s nextPutAll: aString ] ]! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 21:25'!
fileReference

	^ self cacheDirectory / (self title, '.ph')! !

!GTPlayPage methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/22/2014 14:23'!
gtInspectorContentIn: composite
	<gtInspectorPresentationOrder: 40>
	composite pharoPlayground 
		title: 'Content';
		display: #content! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 10/19/2014 13:47'!
initialize
	content := ''.
	title := (DateAndTime now asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title
	^ title! !

!GTPlayPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title: anObject
	title := anObject! !

GLMCompositePresentation subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: 'GTPlaygroundEnabledStatus'
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlayground commentStamp: 'TudorGirba 2/10/2014 11:31' prior: 0!
self open.
self reset.

Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

self registerToolsOn: Smalltalk tools
!

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 10/18/2014 21:52'!
edit: aString label: aLabel

"Open a new playground with the given contents"
"Compatibility with the original Workspace"
"#edit: aText label: labelString accept: anAction"
"	^(Smalltalk tools workspace openLabel: labelString)
		acceptContents:  aText;
		acceptAction: anAction;
		yourself."

"Open an editor on the given string/text"
	| page |
	"self halt"

	page := GTPlayPage new
		content: aString;
		title: aLabel;
		yourself.
		
	self flag: #TODO. "We need to put an equivalent to the acceptAction thing."
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/29/2014 00:39'!
isGTPlaygroundEnabled

	^ GTPlaygroundEnabledStatus ifNil: [ GTPlaygroundEnabledStatus := Smalltalk tools workspace = self ]! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
open
	"self open"
	| page |
	page := GTPlayPage new.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
openContents: aString
	"Open a new playground with the given contents. aString has to be Smalltalk code. The style is applied"
	

	| page |
	
	page := GTPlayPage new
		content: aString;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 10/18/2014 21:52'!
openContents: aString label: aLabel
	"Open a new playground with the given contents"

	| page |

	page := GTPlayPage new
		content: aString;
		title: aLabel;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'compatibility-tools' stamp: 'TudorGirba 10/18/2014 21:52'!
openLabel: aLabel
	| page |

	page := GTPlayPage new
		title: aLabel;
		yourself.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/28/2014 21:33'!
register

	self registerToolsOn: Smalltalk tools! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/9/2014 01:10'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]"
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #workspace
! !

!GTPlayground class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/28/2014 21:33'!
setGTPlaygroundEnabledStatus: aBoolean
	| oldStatus |
	
	oldStatus := self isGTPlaygroundEnabled.
	GTPlaygroundEnabledStatus := aBoolean.
	oldStatus ~= GTPlaygroundEnabledStatus ifTrue: [ 
		GTPlaygroundEnabledStatus 
			ifTrue: [ self register ]
			ifFalse: [ Workspace registerToolsOn: Smalltalk tools ] ]
	
	! !

!GTPlayground class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/28/2014 21:47'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTPlaygroundStatus)
		target: self;
		parent: #gt;
		getSelector: #isGTPlaygroundEnabled;
		setSelector: #setGTPlaygroundEnabledStatus:; 
		label: 'GTPlayground';
		description: 'Enable or disable the GTPlayground.'! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/11/2014 22:23'!
taskbarIcon
	"Answer the icon for the receiver in a task bar."

	^ Smalltalk ui icons iconNamed: #workspaceIcon! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2014 23:02'!
acceptAction: anAction
	"acceptAction := anAction."! !

!GTPlayground methodsFor: 'accessing' stamp: 'AndreiChis 9/30/2014 20:46'!
acceptContents: aString

	^ (self entity acceptContents: aString)
		ifTrue: [  
			self update.
			true]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/20/2014 06:47'!
actionsForPreviousContents
	^ GTPlayBook instance pages
		collect: [ :each | 
			GLMGenericAction new
				title: (each content asString contractTo: 50);
				action: [ :text | 
					| page |
					page := GTPlayPage new.
					page content: each content.
					text entity: page.
					text update ];
				yourself ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/17/2014 15:27'!
codeIn: a
	^ a pharoPlayground
		title: [ :page | page title ];
		format: [ :page | page content ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text evaluateSelectionAndDo: [ :result | text selection: result ]  ]
			icon: GLMUIThemeExtraIcons glamorousGo
"			on: $G"
			entitled: 'Do it all and go';
		installGoAction;
		installDefaultSelectionActions;
		dynamicActions: [ self actionsForPreviousContents ];
		onChangeOfPort: #text act: [ :text :page | page content: text text ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/20/2014 07:11'!
compose
	self
		title: 'Playground';
		custom:
			(GTInspector new
				noTitle; 
				noActions;
				showFirst: [ :composite |
					self codeIn: composite ];
				yourself);
		on: GLMBrowserClosing do: [ 
			"This is a hack for the moment.
			We need a better mechanism from Glamour to help 
			us keep the model in sync"
			self entity
					content: self first panes first presentations first text.
			GTPlayBook instance addPageIfInteresting: self entity ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 10/18/2014 21:52'!
pushToRepositoryFrom: aTextPresentation
	| page |
	page := GTPlayPage new.
	page content: aTextPresentation text.
	page content asString trimBoth isEmpty
		ifFalse: [ GTPlayBook instance addPage: page ] ! !
